#ifndef __S4CDCMCTRUTH__
#define __S4CDCMCTRUTH__

//*************************************************************************
//* ----------------
//* S4CDCMCTruth Class
//* ----------------
//* (Description)
//* (Requires)
//*	S4VMCTruth:
//* (Provides)
//*	S4CDCMCTruth		: steering class
//* (Update Record)
//*	2001/08/20  K.Hoshina	Original version.
//*************************************************************************

#include <fstream>
#include "S4VMCTruth.h"

#include "S4CDCTypeDef.h"

class S4CDCMCTruth : public S4VMCTruth {
	
public:
   S4CDCMCTruth(const Char_t *name="S4CDCMCTruth",
	        const Char_t *title="Get CDC ExactHit data");
	        
   virtual ~S4CDCMCTruth();

   Bool_t BeginRun(Int_t nrun);
   Bool_t Process (Int_t ev);
   void   DebugPrint(const Char_t *opt = "");
   
   void   RemoveDeltaRayHits(Bool_t flag = kTRUE) 
   			{ fRemoveDeltaRayHits = flag; }
   void   JoinSeparatedHits(Bool_t flag = kTRUE) 
   			{ fJoinSeparatedHits = flag; }
   
private:
   Bool_t          fRemoveDeltaRayHits;         //
   Bool_t          fJoinSeparatedHits;          //

   ClassDef(S4CDCMCTruth, 1) // Read CDC ExactHit Data
};

#endif




