#ifndef __S4MUDMCTRUTH__
#define __S4MUDMCTRUTH__
//*************************************************************************
//* ----------------
//* S4MUDMCTruth Class
//* ----------------
//* (Description)
//* (Requires)
//*	S4VMCTruth:
//* (Provides)
//*	S4MUDMCTruth		: steering class
//* (Update Record)
//*	2004/11/25  S.Yamamoto	Original version.
//*************************************************************************

#include <fstream>
#include "S4VMCTruth.h"

using namespace std;

class S4MUDMCTruth : public S4VMCTruth {

public:
   S4MUDMCTruth(const Char_t *fname = "hit.dat", 
                const Char_t *name  = "S4MUDMCTruth",
                const Char_t *title = "Get MUD ExactHit data");
	        
   virtual ~S4MUDMCTruth();

   Bool_t BeginRun(Int_t nrun);
   Bool_t Process (Int_t ev);

   void   DebugPrint(const Char_t *opt = "");
   
private:
   Char_t    *fInputFileName;            //!
   ifstream  *fInputStream;              //!

   ClassDef(S4MUDMCTruth, 1) // Read MUD ExactHit Data
};

#endif

