//*************************************************************************
//* --------------------
//* S4HYBTrackMakerBuf
//* --------------------
//* (Description)
//*	This set of classes makes pad Tracks.
//* (Requires)
//* (Provides)
//* (Update Record)
//*	2001/08/22  K.Hoshina	Original version.
//*************************************************************************

#include <iostream>
#include "S4HYBTrackMakerBuf.h"
#include "S4HYBTrack.h"

//#define __DEBUG__

ClassImp(S4HYBTrackMakerBuf)

//=====================================================================
//* constructor -------------------------------------------------------
S4HYBTrackMakerBuf::S4HYBTrackMakerBuf(const Char_t    *name,
				       const Char_t    *title, 
				       S4HYBTrackMaker *module,
	                               Int_t            bufsize)
                   : U4HYBTrackMakerBuf(name, title, module, bufsize)
{
}	       
	       
S4HYBTrackMakerBuf::S4HYBTrackMakerBuf(S4HYBTrackMaker *module,
			               const Char_t    *name,
	                               const Char_t    *title, 
	                               Int_t            bufsize)
                   : U4HYBTrackMakerBuf(module, name, title, bufsize)
{
}	       

//=====================================================================
//* destructor --------------------------------------------------------

S4HYBTrackMakerBuf::~S4HYBTrackMakerBuf()
{
}

//=====================================================================
//* MakeTracks ----------------------------------------------------------

void S4HYBTrackMakerBuf::MakeTracks()
{
   U4HYBTrackMakerBuf::MakeTracks();
   MakeMap();
}

//=====================================================================
//* MakeMap -----------------------------------------------------------

void S4HYBTrackMakerBuf::MakeMap()
{
   fJ4TrackMap.clear();
   TObjArray *htrksp = GetOutputBufPtr();
   if (!htrksp->GetEntries()) return;

   TIter next(htrksp);
   S4HYBTrack *htrkp = 0;
   while ((htrkp = static_cast<S4HYBTrack *>(next()))) {
      Int_t j4trkid = htrkp->GetTrackID();
      fJ4TrackMap[j4trkid] = htrkp;
#if 0
      std::cerr << "j4trkid = " << j4trkid << " htrkp = " << (void *)htrkp << std::endl;
#endif
   }
}

//=====================================================================
//* GetHYBTrackPtr ----------------------------------------------------

S4HYBTrack *S4HYBTrackMakerBuf::GetHYBTrackPtr(Int_t j4trkid)
{
   std::map<Int_t,S4HYBTrack *>::iterator iter = fJ4TrackMap.find(j4trkid);
   if (iter != fJ4TrackMap.end()) {
      return static_cast<S4HYBTrack *>(iter->second);
   } else {
      return 0;
   }
}
