#ifndef __S4ITANALYSIS__
#define __S4ITANALYSIS__
//*************************************************************************
//* -----------
//* S4ITAnalysis
//* -----------
//* (Description)
//* 	Clasess to analyze IT data.
//* (Update Record)
//*	2004/09/06  A.Yamaguchi	Original version.
//*************************************************************************

#include "TNtupleD.h"
#include "JSFModule.h"

class S4ITAnalysis : public JSFModule {
public:
   S4ITAnalysis(const Char_t *name  = "S4ITAnalysis",
                const Char_t *title = "IT Analysis");
   virtual ~S4ITAnalysis();

   virtual Bool_t Initialize();
   virtual Bool_t Process(Int_t ev);
   virtual Bool_t Terminate();
    
   void Draw(Option_t *option = "");

private:
   virtual void MonitorTracks(Int_t ev);
   
private:
   TNtupleD *fTrackHistPtr;
   TNtupleD *fHitHistPtr;

   ClassDef(S4ITAnalysis, 1) // IT Analysis class
};

#endif

