#ifndef __S4ITTRACKMAKERBUF__
#define __S4ITTRACKMAKERBUF__
//*************************************************************************
//* ---------------------
//* S4ITTrackMakerBuf Class
//* ---------------------
//* (Description)
//*
//* (Requires)
//*	JSFEventBuf
//* (Provides)
//*	S4ITTrackMakerBuf		: buffering class
//* (Update Record)
//*	2004/08/26  A.Yamaguchi	    Original version.
//*************************************************************************

#include "U4ITTrackMakerBuf.h"
#include "S4ITTrackMaker.h"
#include "S4ITHitMakerBuf.h"

class S4ITTrack;

class S4ITTrackMakerBuf : public U4ITTrackMakerBuf {
friend class S4ITTrackMaker;

public:
  S4ITTrackMakerBuf(const Char_t   *name   = "S4ITTrackMakerBuf",
                    const Char_t   *title  = "IT Track data",
                    S4ITTrackMaker *module = 0,
                    Int_t           size   = 2000);

  S4ITTrackMakerBuf(S4ITTrackMaker *module,
                    const Char_t   *name  = "S4ITTrackMakerBuf",
                    const Char_t   *title = "IT Track data",
                    Int_t           size  = 2000);
		    
  virtual ~S4ITTrackMakerBuf();
  
  virtual U4VTrack *MakeOneTrack(U4VTrack *htkp);  // Make a IT Track
  virtual void      DebugPrint(const Char_t *opt = "Brief");

private:  

  ClassDef(S4ITTrackMakerBuf, 1) // Cluster data buffer
};

#endif
