//*************************************************************************
//* --------------------
//* S4PFOFilter
//* --------------------
//* (Description)
//*	This set of classes makes Particle Flow Objects.
//* (Requires)
//*     JSFModules:
//* (Provides)
//*     S4PFOFilter              : steering class          
//* (Update Record)
//*	2004/11/15  S.Yamamoto	Original version.
//*************************************************************************

#include <iostream>

#include "S4PFObject.h"
#include "S4PFOFilter.h"

ClassImp(S4PFOFilter)

//=====================================================================
//* constructor -------------------------------------------------------

S4PFOFilter::S4PFOFilter(Double_t emin)
           : fEmin(emin)       // filter cut[GeV]  
{
}

//=====================================================================
//* destructor --------------------------------------------------------

S4PFOFilter::~S4PFOFilter()
{
}

//=====================================================================
//* IsOK -----------------------------------------------------------

Bool_t S4PFOFilter::IsOK(const S4PFObject &pfo)
{
  return pfo.E() > fEmin;
}
