#ifndef __S4V0FINDER__
#define __S4V0FINDER__

//*************************************************************************
//* ---------------------
//* S4V0Finder Class
//* ---------------------
//* (Description)
//*     This class finds V0s and locks daughter PFOs.
//* (Requires)
//*     
//* (Provides)
//*     S4V0Finder            : steering class
//* (Update Record)
//*     2006/06/20  S.Yamamoto  Original version.
//*************************************************************************

#include "TVector3.h"
#include "JSFHelicalTrack.h"
#include "S4PFObject.h"

class S4V0Finder {

 public:
  S4V0Finder();
  virtual ~S4V0Finder();

  void   FindV0s();
  Double_t FitV0(S4PFObject &v0pfo, TVector3 &xv, TVector3 &pv, Double_t &e);

 private:
  // Data Getters
  TVector3 GetPosition(JSFHelicalTrack &helix1, JSFHelicalTrack &helix2, Double_t &quality);
  TVector3 GetMomentum(JSFHelicalTrack &helix1, JSFHelicalTrack &helix2);

  ClassDef(S4V0Finder, 1) // V0 Finder
};

#endif
