#ifndef __S4VTXANALYSIS__
#define __S4VTXANALYSIS__
//*************************************************************************
//* -----------
//* S4VTXAnalysis
//* -----------
//* (Description)
//* 	Clasess to analyze VTX data.
//* (Update Record)
//*	2004/09/06  A.Yamaguchi	Original version.
//*************************************************************************

#include "TNtupleD.h"
#include "JSFModule.h"

class S4VTXAnalysis : public JSFModule {
public:
   S4VTXAnalysis(const Char_t *name  = "S4VTXAnalysis",
                 const Char_t *title = "VTX Analysis");
   virtual ~S4VTXAnalysis();

   virtual Bool_t Initialize();
   virtual Bool_t Process(Int_t ev);
   virtual Bool_t Terminate();
    
   void Draw(Option_t *option = "");

private:
   virtual void MonitorTracks(Int_t ev);
   
private:
   TNtupleD *fTrackHistPtr;
   TNtupleD *fHitHistPtr;

   ClassDef(S4VTXAnalysis, 1) // VTX Analysis class
};

#endif

