#ifndef __S4VTXTRACKMAKERBUF__
#define __S4VTXTRACKMAKERBUF__
//*************************************************************************
//* ---------------------
//* S4VTXTrackMakerBuf Class
//* ---------------------
//* (Description)
//*
//* (Requires)
//*	JSFEventBuf
//* (Provides)
//*	S4VTXTrackMakerBuf		: buffering class
//* (Update Record)
//*	2004/08/26  A.Yamaguchi	    Original version.
//*************************************************************************

#include "U4VTXTrackMakerBuf.h"
#include "S4VTXTrackMaker.h"
#include "S4VTXHitMakerBuf.h"

class S4VTXTrack;

class S4VTXTrackMakerBuf : public U4VTXTrackMakerBuf {
friend class S4VTXTrackMaker;

public:

  S4VTXTrackMakerBuf(const Char_t    *name   = "S4VTXTrackMakerBuf",
                     const Char_t    *title  = "VTX Track data",
		     S4VTXTrackMaker *module = 0,
		     Int_t            bufsize   = 2000);

  S4VTXTrackMakerBuf(S4VTXTrackMaker *module,
                     const Char_t    *name  = "S4VTXTrackMakerBuf",
                     const Char_t    *title = "VTX Track data",
                     Int_t            bufsize  = 2000);
		    
  virtual ~S4VTXTrackMakerBuf();
  
  virtual U4VTrack* MakeOneTrack(U4VTrack *htkp);  // Make a VTX track
  virtual void 	DebugPrint(const Char_t *opt = "Brief");

private:  
  ClassDef(S4VTXTrackMakerBuf, 1) // Cluster data buffer
};

#endif
