#ifndef __U4CDCHITLAYER__
#define __U4CDCHITLAYER__

//*************************************************************************
//* ---------------------
//* U4CDCHitLayer Class
//* ---------------------
//* (Description)
//*	Class to store "U4CDCHitCell"s for a single layer.
//* (Requires)
//*	TObjArray
//* (Provides)
//*	U4CDCHitLayer		: Array containing "U4CDCHitCell"s
//* (Update Record)
//*	1999/12/04  K.Fujii	Original version.
//*************************************************************************

#include "TObjArray.h"
#include "U4CDCHitCell.h"

class U4CDCHitCell;

class U4CDCHitLayer : public TObjArray {
public:
  U4CDCHitLayer();
  virtual ~U4CDCHitLayer();

  inline virtual Int_t	GetLayerNumber() const { return fLayerNumber; }

  virtual Int_t		Append(U4CDCHitCell* cell);

  virtual Bool_t	IsSortable() const;
  virtual Int_t		Compare(const TObject* obj) const;

  virtual void 		DebugPrint(const Char_t* opt = "Brief");

private:
  Int_t		fLayerNumber;		// layer Number.
 
  ClassDef(U4CDCHitLayer, 1) 	// CDC Hit Layer
};

#endif
