#ifndef __U4CDCTRACKHIT__
#define __U4CDCTRACKHIT__
//*************************************************************************
//* ---------------------
//* U4CDCTrackHit Class
//* ---------------------
//* (Description)
//*	Class for a single track hit.
//* (Requires)
//*	TObjArray
//* (Provides)
//*	U4CDCTrackHit : 
//* (Update Record)
//*	2002/08/28  R.Kuboshima	   Original version.
//*	2004/09/05  K.Fujii        Now inherits from U4VTrack.
//*************************************************************************

#include "U4VTrackHit.h"
#include "U4CDCHit.h"

class U4CDCVectorHit;

class U4CDCTrackHit : public U4VTrackHit {
friend class U4CDCTrack;
public:

  U4CDCTrackHit(U4CDCHit *ht = 0, Int_t lr = 0);
  U4CDCTrackHit(const U4CDCTrackHit &hit);
  virtual ~U4CDCTrackHit();

  static  void   SetSortBy (Char_t *opt = "WireLayer");
  virtual Bool_t IsSortable()                   const;
  virtual Int_t  Compare   (const TObject *obj) const;
       
  inline virtual Int_t	         GetLeftRight   () const { return fLeftRight; }
  inline virtual U4CDCHit       *GetHitPtr      () 
                 {
                    return dynamic_cast<U4CDCHit *>(U4VTrackHit::GetHitPtr());
                 }
  inline virtual U4CDCVectorHit *GetVectorHitPtr() const { return fVHitPtr;   }

  inline virtual void SetLeftRight   (Int_t lr)            { fLeftRight = lr;  }
  inline virtual void SetVectorHitPtr(U4CDCVectorHit *vhp) { fVHitPtr   = vhp; }

private:
  Int_t	           fLeftRight;	  // (-1,1) = (left,right)
  U4CDCVectorHit  *fVHitPtr; // pointer to U4CDCVectorHit.

  ClassDef(U4CDCTrackHit, 1) 	  // CDC Hit Wire
};


#endif
