#include "U4ITFBKalHit.h"

#include <iostream>
#include <iomanip>

using namespace std;

ClassImp(U4ITFBKalHit)

//_____________________________________________________________________
//  ----------------------------------
//  Ctors and Dtor
//  ----------------------------------

U4ITFBKalHit::U4ITFBKalHit(Int_t m)
         : U4VKalHit(m)
{
}
      
U4ITFBKalHit::U4ITFBKalHit(const TObject    &hit,
                           const U4ITFBMeasLayer &ms,
                           Double_t        *x,
                           Double_t        *dx, 
                           Double_t         b,
                           Int_t            m)
         : U4VKalHit(hit, ms, x, dx, b, m)
{
}

U4ITFBKalHit::~U4ITFBKalHit()
{
}

//_____________________________________________________________________
//  ----------------------------------
//  Implementation of public methods  
//  ----------------------------------

TKalMatrix U4ITFBKalHit::XvToMv(const TVector3 &xv, Double_t /*t0*/) const
{
   return dynamic_cast<const U4ITFBMeasLayer &>(GetMeasLayer()).XvToMv(xv);
}

void U4ITFBKalHit::DebugPrint(Option_t *) const
{
   cerr << "------------------- Site Info -------------------------" << endl;
   cerr << " x  = " << setw(8) << setprecision(5) << (*this)(0,0)
        << " dx = " << setw(6) << setprecision(2) << (*this)(0,1) << endl
        << " y  = " << setw(8) << setprecision(5) << (*this)(1,0)
        << " dy = " << setw(6) << setprecision(2) << (*this)(1,1) << endl
        << " z  = " << setprecision(7) << resetiosflags(ios::showpoint)
                    << dynamic_cast<const U4ITFBMeasLayer &>
                      (GetMeasLayer()).GetXc().Z()                << endl;
   cerr << "-------------------------------------------------------" << endl;
}
