#ifndef __U4VTXTRACK__
#define __U4VTXTRACK__
//*************************************************************************
//* ---------------------
//* U4VTXTrack Class
//* ---------------------
//* (Description)
//*	Class to store "U4VTXTrackHit"s for a single layer.
//* (Requires)
//*	TObjArray
//* (Provides)
//*	U4VTXTrack		: Array containing "U4VTXTrackHit"s
//* (Update Record)
//*	2004/09/06  A.Yamaguchi     Original version.
//*************************************************************************

#include "U4VTXTrackMaker.h"
#include "U4VTrack.h"


class U4VTXTrack : public U4VTrack {
public:
   // ----------------------------------------------------------------------
   // Constractors and Destractor 
   // ----------------
   U4VTXTrack();
   U4VTXTrack(U4VTXTrackMaker *trkm);
   U4VTXTrack(const U4VTXTrack &tk);
   virtual ~U4VTXTrack();
 
   // ----------------------------------------------------------------------
   // Service methods
   // ---------------
   virtual void  DebugPrint(const Char_t *opt = "Brief");
   virtual Int_t GetNhits  ();

   virtual void           MakeKalHits (TObjArray &kalhits);  
   virtual TKalTrackSite *GetFirstSitePtr(Bool_t dir, TObjArray *hitsp = 0);

   virtual void KalmanFilter(Bool_t dir = kIterBackward);
  
  ClassDef(U4VTXTrack, 1)                  // VTX Track
};


#endif
